package cn.estsh.i3plus.pojo.platform.sqlpack;

import cn.estsh.i3plus.pojo.base.enumutil.CommonEnumUtil;
import cn.estsh.i3plus.pojo.base.tool.HqlPack;
import cn.estsh.i3plus.pojo.platform.bean.*;
import org.apache.commons.lang3.StringUtils;

import java.util.List;

/**
 * @Description : 平台对象封装
 * @Reference :
 * @Author : alwaysfrin
 * @CreateDate : 2018-10-23 21:15
 * @Modify:
 **/
public class CoreHqlPack {

    /**
     * In 参数封装
     * @param columnName
     * @return
     */
    public static String packHqlIds(String columnName,String[] params){
        StringBuffer result =  new StringBuffer();

        // 参数数组 [1,2,3] -> "1,2,3"
        HqlPack.getInPack(String.join(",",params),columnName,result);
        return result.toString();
    }


    /**
     * In 参数封装
     * @param columnName
     * @return
     */
    public static String packHqlIds(String columnName,Long[] params){
        StringBuffer result =  new StringBuffer();

        // 参数数组 [1,2,3] -> "1,2,3"
        HqlPack.getInPack(StringUtils.join(params,","),columnName,result);
        return result.toString();
    }

    /**
     * 资源查询
     * @param localeResource
     * @return
     */
    public static String packHqlSysLocaleResource(SysLocaleResource localeResource){
        StringBuffer result = new StringBuffer();

        //查询日期
//        HqlPack.timeBuilder(sysLocaleResource.getCreateDateTimeStart(),sysLocaleResource.getCreateDateTimeEnd(),
//                "createDateTime", result, false);
        //数字类型封装
        HqlPack.getNumEqualPack(localeResource.getResourceType(),"resourceType",result);
        //字符串类型封装
        HqlPack.getStringEqualPack(localeResource.getLanguageCode(),"languageCode",result);
        //字符串类型封装
        HqlPack.getStringLikerPack(localeResource.getResourceKey(),"resourceKey",result);

        return result.toString();
    }

    /**
     * 语言
     * @param localeLanguage
     * @return
     */
    public static String packHqlSysLocaleLanguage(SysLocaleLanguage localeLanguage) {
        StringBuffer result = new StringBuffer();

        //查询日期
//        HqlPack.timeBuilder(lang.getCreateDateTimeStart(),lang.getCreateDateTimeEnd(),
//                "createDateTime", result, false);
        //字符串类型封装
        HqlPack.getStringLikerPack(localeLanguage.getLanguageCode(),"languageCode",result);
        //字符串类型封装
        HqlPack.getStringLikerPack(localeLanguage.getLanguageName(),"languageName",result);

        return result.toString();
    }

    /**
     * 岗位复杂查询
     * @param position
     * @return
     */
    public static String packHqlSysPosition(SysPosition position){
        StringBuffer result = new StringBuffer();

        // 查询参数封装
        HqlPack.getNumEqualPack(position.getParentId(),"parentId",result);
        HqlPack.getStringLikerPack(position.getName(),"name",result);
        HqlPack.getStringLikerPack(position.getPositionCode(),"positionCode",result);

        return result.toString();
    }

    /**
     * 组织复杂查询
     * @param organize
     * @return
     */
    public static String packHqlSysOrganize(SysOrganize organize){
        StringBuffer result = new StringBuffer();

        // 查询参数封装
        HqlPack.getNumEqualPack(organize.getParentId(),"parentId",result);
        HqlPack.getStringLikerPack(organize.getName(),"name",result);
        HqlPack.getStringLikerPack(organize.getOrganizeCode(),"organizeCode",result);

        return result.toString();
    }

    public static String packHqlSysOrganize(Long[] ids, Integer typeId){
        StringBuffer result = new StringBuffer();

        // 查询参数封装
        HqlPack.getInPack(StringUtils.join(ids,","),"id",result);
        HqlPack.getNumEqualPack(typeId,"organizeType",result);

        return result.toString();
    }

    /**
     * 部门复杂查询
     * @param department
     * @return
     */
    public static String packHqlSysDepartment(SysDepartment department){
        StringBuffer result = new StringBuffer();

//        if(department.getOrganizeId() != null && department.getOrganizeId() > 0){
//            department.setParentId(CommonEnumUtil.PARENT.DEFAULT.getValue());
//        }

        HqlPack.getNumEqualPack(department.getParentId(),"parentId",result);
//        HqlPack.getNumEqualPack(department.getOrganizeId(),"organizeId",result);
        HqlPack.getStringLikerPack(department.getName(),"name",result);
        HqlPack.getStringLikerPack(department.getDepartmentCode(),"departmentCode",result);

        return result.toString();
    }

    /**
     * 系统权限复杂查询
     * @param menu
     * @return
     */
    public static String packHqlSysMenu(SysMenu menu){
        StringBuffer result = new StringBuffer();

        // 查询参数封装
        HqlPack.getNumEqualPack(menu.getParentId(),"parentId",result);
        HqlPack.getNumEqualPack(menu.getMenuType(),"menuType",result);
        HqlPack.getNumEqualPack(menu.getMenuStatus(),"menuStatus",result);
        HqlPack.getStringLikerPack(menu.getName(),"name",result);
        HqlPack.getStringLikerPack(menu.getMenuCode(),"menuCode",result);

        return result.toString();
    }

    /**
     * 系统角色复杂查询
     * @param role
     * @return
     */
    public static String packHqlSysRole(SysRole role){
        StringBuffer result = new StringBuffer();

        // 查询参数封装
        HqlPack.getNumEqualPack(role.getRoleStatus(),"roleStatus",result);
        HqlPack.getStringLikerPack(role.getName(),"name",result);

        return result.toString();
    }

    /**
     * 系统参数复杂查询
     * @param config
     * @return
     */
    public static String packHqlSysConfig(SysConfig config) {
        StringBuffer result = new StringBuffer();

        // hql拼接
        HqlPack.getStringLikerPack(config.getName(),"name",result);
        HqlPack.getStringLikerPack(config.getConfigCode(),"configCode",result);
        HqlPack.getNumEqualPack(config.getConfigType(),"configType",result);

        return result.toString();
    }

    /**
     * 字典信息复杂查询
     * @param dictionary
     * @return
     */
    public static String packHqlSysDictionary(SysDictionary dictionary) {
        StringBuffer result = new StringBuffer();

        // hql拼接
        HqlPack.getStringLikerPack(dictionary.getName(),"name",result);
        HqlPack.getStringLikerPack(dictionary.getDictionaryCode(),"dictionaryCode",result);
        // 默认查询非顶级字典
        if(dictionary.getParentId() == null || dictionary.getParentId() < 1){
            HqlPack.getNumNOEqualPack(CommonEnumUtil.PARENT.DEFAULT.getValue(),"parentId",result);
        }
        HqlPack.getNumEqualPack(dictionary.getParentId(),"parentId",result);

        return result.toString();
    }

    /**
     * 硬件类型复杂查询
     * @param toolType
     * @return
     */
    public static String packHqlSysToolType(SysToolType toolType) {
        StringBuffer result = new StringBuffer();

        // hql拼接
        HqlPack.getStringLikerPack(toolType.getName(),"name",result);

        return result.toString();
    }

    /**
     * 硬件复杂查询
     * @param tool
     * @return
     */
    public static String packHqlSysTool(SysTool tool) {
        StringBuffer result = new StringBuffer();

        // hql拼接
        HqlPack.getStringLikerPack(tool.getName(),"name",result);
        HqlPack.getNumEqualPack(tool.getToolTypeId(),"toolTypeId",result);
        HqlPack.getNumEqualPack(tool.getToolStatus(),"toolStatus",result);
        HqlPack.getNumEqualPack(tool.getToolDataType(),"toolDataType",result);
        HqlPack.getNumEqualPack(tool.getToolConnType(),"toolConnType",result);
        HqlPack.getStringLikerPack(tool.getToolIp(),"toolIp",result);
        HqlPack.getNumLikerPack(tool.getToolPort(),"toolPort",result);

        return result.toString();
    }

    /**
     * 消息复杂查询
     * @param message
     * @return
     */
    public static String packHqlSysMessage(SysMessage message){
        StringBuffer result = new StringBuffer();

        // hql拼接
        HqlPack.getStringLikerPack(message.getMessageTitle(),"messageTitle",result);
        HqlPack.getStringLikerPack(message.getMessageContent(),"messageContent",result);
        HqlPack.getNumEqualPack(message.getMessageType(),"messageType",result);
        HqlPack.getStringLikerPack(message.getMessageSenderNameRdd(),"messageSenderNameRdd",result);
        HqlPack.getStringLikerPack(message.getMessageReceiversNameRdd(),"messageReceiversNameRdd",result);
        HqlPack.timeBuilder(message.getMessageSendTime(),"messageSendTime", result, false,false);

        return  result.toString();
    }

    /**
     * 文件资源复杂查询
     * @param file
     * @return
     */
    public static String packHqlSysFile(SysFile file) {
        StringBuffer result = new StringBuffer();

        // hql拼接
        HqlPack.getStringLikerPack(file.getName(),"name",result);
        HqlPack.getNumEqualPack(file.getFileTypeId(),"fileTypeId",result);
        HqlPack.getStringLikerPack(file.getCreateUser(),"createUser",result);
        HqlPack.timeBuilder(file.getCreateDatetime(),"createDatetime",result,false,false);

        return  result.toString();
    }

    /**
     * 任务表达式复杂查询
     * @param taskTimeExpression
     * @return
     */
    public static String packHqlSysTaskTimeExpression(SysTaskTimeExpression taskTimeExpression) {
        StringBuffer result = new StringBuffer();

        // hql拼接
        HqlPack.getStringLikerPack(taskTimeExpression.getName(),"name",result);

        return  result.toString();
    }

    /**
     * 定时任务复杂查询
     * @param taskTime
     * @return
     */
    public static String packHqlSysTaskTime(SysTaskTime taskTime){
        StringBuffer result = new StringBuffer();

        // hql拼接
        HqlPack.getStringLikerPack(taskTime.getName(),"name",result);
        HqlPack.getNumEqualPack(taskTime.getTaskStatus(),"taskStatus",result);
        HqlPack.getNumEqualPack(taskTime.getTimeExpressionId(),"timeExpressionId",result);

        return  result.toString();
    }

    /**
     * 账号复杂查询
     * @param user
     * @return
     */
    public static String packHqlSysUser(SysUser user){
        StringBuffer result = new StringBuffer();

        // And X = X
        HqlPack.getNumEqualPack(user.getIsValid(),"isValid",result);
        HqlPack.getNumEqualPack(user.getDepartmentId(),"departmentId",result);
        HqlPack.getNumEqualPack(user.getRoleId(),"roleId",result);
        HqlPack.getNumEqualPack(user.getUserStatus(),"userStatus",result);
        // And Like % %
        HqlPack.getStringLikerPack(user.getUserName(),"userName",result);
        HqlPack.getStringLikerPack(user.getUserLoginName(),"userLoginName",result);
        HqlPack.getStringLikerPack(user.getUserEmail(),"userEmail",result);
        HqlPack.getStringLikerPack(user.getUserPhone(),"userPhone",result);

        return  result.toString();
    }

    /**
     * 查询字典代码是否重复
     * @param dictionary
     * @return
     */
    public static String packHqlSysDictionaryCode(SysDictionary dictionary){
        StringBuffer result = new StringBuffer();

        // and
        HqlPack.getStringEqualPack(dictionary.getDictionaryCode(),"dictionaryCode",result);
        // not
        HqlPack.getNumNOEqualPack(dictionary.getId(),"id",result);

        return result.toString();
    }

    /**
     * 查询字典值是否重复
     * @param dictionary
     * @return
     */
    public static String packHqlSysDictionaryValue(SysDictionary dictionary){
        StringBuffer result = new StringBuffer();

        // and
        HqlPack.getStringEqualPack(dictionary.getDictionaryValue(),"dictionaryValue",result);
        // not
        HqlPack.getNumNOEqualPack(dictionary.getId(),"id",result);

        return result.toString();
    }

    /**
     * 用户信息 复杂查询拼接
     * @param userInfo
     * @return
     */
    public static String packHqlSysUserInfo(SysUserInfo userInfo){
        StringBuffer result = new StringBuffer();

        // And
        HqlPack.getNumEqualPack(userInfo.getOrganizeId(),"organizeId",result);
        HqlPack.getNumEqualPack(userInfo.getDepartmentId(),"departmentId",result);
        HqlPack.getNumEqualPack(userInfo.getPositionId(),"positionId",result);
        HqlPack.getNumEqualPack(userInfo.getUserInfoStatus(),"userInfoStatus",result);

        // Like
        HqlPack.getStringLikerPack(userInfo.getName(),"name",result);
        HqlPack.getStringLikerPack(userInfo.getUserEmpNo(),"userEmpNo",result);

        return  result.toString();
    }

    /**
     * 查询语言代码是否重复
     * @param localeLanguage
     * @return
     */
    public static String packHqlSysLocaleLanguageCode(SysLocaleLanguage localeLanguage){
        StringBuffer result = new StringBuffer();

        HqlPack.getStringEqualPack(localeLanguage.getLanguageCode(),"languageCode",result);
        HqlPack.getNumNOEqualPack(localeLanguage.getId(),"id",result);

        return result.toString();
    }

    /**
     * 检查系统资源是否重复
     * @param localeResource
     * @return
     */
    public static String packHqlSysLocaleResourceKey(SysLocaleResource localeResource){
        StringBuffer result = new StringBuffer();

        HqlPack.getStringEqualPack(localeResource.getLanguageCode(),"languageCode",result);
        HqlPack.getStringEqualPack(localeResource.getResourceKey(),"resourceKey",result);
        HqlPack.getNumNOEqualPack(localeResource.getId(),"id",result);

        return result.toString();
    }

    /**
     * 查询规则代码是否重复
     * @param sysOrderNoRule
     * @return
     */
    public static String packHqlSysOrderNoRuleCode(SysOrderNoRule sysOrderNoRule){
        StringBuffer result = new StringBuffer();

        // and
        HqlPack.getStringEqualPack(sysOrderNoRule.getOrderNoRuleCode(),"orderNoRuleCode",result);
        // not
        HqlPack.getNumNOEqualPack(sysOrderNoRule.getId(),"id",result);

        return result.toString();
    }

    /**
     *  单号规则复杂查询，分页，排序
     * @param sysOrderNoRule
     * @return
     */
    public static String packHqlSysOrderNoRule(SysOrderNoRule sysOrderNoRule){
        StringBuffer result =  new StringBuffer();

        HqlPack.getStringLikerPack(sysOrderNoRule.getName(),"name",result);
        HqlPack.getStringLikerPack(sysOrderNoRule.getOrderNoRuleCode(),"orderNoRuleCode",result);

        return result.toString();
    }

    /**
     * 用户消息关系表负责查询
     * @param sysRefUserMessage
     * @return
     */
    public static String packHqlSysRefUserMessage(SysRefUserMessage sysRefUserMessage){
        StringBuffer result =  new StringBuffer();

        HqlPack.getNumEqualPack(sysRefUserMessage.getMessageTypeRdd(),"messageTypeRdd",result);
        HqlPack.getNumEqualPack(sysRefUserMessage.getReceiverId(),"receiverId",result);
        HqlPack.getStringLikerPack(sysRefUserMessage.getMessageTitleRdd(),"messageTitleRdd",result);
        HqlPack.getStringLikerPack(sysRefUserMessage.getMessageSenderNameRdd(),"messageSenderNameRdd",result);
        HqlPack.getNumEqualPack(sysRefUserMessage.getMessageStatus(),"messageStatus",result);
        HqlPack.getStringLikerPack(sysRefUserMessage.getReceiverTime(),"receiverTime",result);

        return result.toString();
    }
}