package cn.estsh.i3plus.pojo.wms.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import javax.persistence.Transient;

/**
 * @Description : 作业流程明细
 * @Reference :
 * @Author : amy
 * @CreateDate : 2018-11-23 13:23
 * @Modify:
 **/
@Data
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Table(name="WMS_ACTION_GROUP_DETAILS")
@Api("作业流程明细")
public class WmsActionGroupDetails extends BaseBean {

    @Column(name = "AG_ID")
    @ApiParam(value = "作业流程ID", example = "0")
    @JsonSerialize(using = ToStringSerializer.class)
    private Long agId;

    @Column(name = "SEQ")
    @ApiParam(value = "序号", example = "0")
    private Integer seq;

    @Column(name = "OK_SEQ")
    @ApiParam(value = "成功跳转步骤", example = "0")
    private Integer okSeq;

    @Column(name = "NG_SEQ")
    @ApiParam(value = "失败跳转步骤", example = "0")
    private Integer ngSeq;

    @Column(name = "VALUE_TYPE")
    @ApiParam(value = "动作类型", example = "10")
    private Integer valueType;

    @Column(name = "TO_UPPER")
    @ApiParam(value = "是否转为大写", example = "2")
    private Integer toUpper;

    @Column(name = "LEN_CHECK")
    @ApiParam(value = "长度检查", example = "0")
    private Integer lenCheck;

    @Column(name = "AS_ID")
    @ApiParam(value = "作业步骤", example = "0")
    @JsonSerialize(using = ToStringSerializer.class)
    private Long asId;

    @Transient
    @ApiParam(value = "作业步骤名称")
    private String asName;

    @Transient
    @ApiParam(value = "流程名称")
    private String agName;


}
